diff -uNr openmp-3.5.0.src/runtime/src/kmp_settings.c openmp-3.5.0.src.r219214/runtime/src/kmp_settings.c
--- openmp-3.5.0.src/runtime/src/kmp_settings.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_settings.c	2014-10-24 19:58:40.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * kmp_settings.c -- Initialize environment variables
- * $Revision: 42816 $
- * $Date: 2013-11-11 15:33:37 -0600 (Mon, 11 Nov 2013) $
+ * $Revision: 43473 $
+ * $Date: 2014-09-26 15:02:57 -0500 (Fri, 26 Sep 2014) $
  */
 
 
@@ -534,9 +534,9 @@
     * out = __kmp_str_format( "%s", buffer );
 } // __kmp_stg_parse_file
 
+#ifdef KMP_DEBUG
 static char * par_range_to_print = NULL;
 
-#ifdef KMP_DEBUG
 static void
 __kmp_stg_parse_par_range(
     char const * name,
@@ -945,6 +945,26 @@
 } // __kmp_stg_print_settings
 
 // -------------------------------------------------------------------------------------------------
+// KMP_STACKPAD
+// -------------------------------------------------------------------------------------------------
+
+static void
+__kmp_stg_parse_stackpad( char const * name, char const * value, void * data ) {
+    __kmp_stg_parse_int(
+        name,                             // Env var name
+        value,                            // Env var value
+        KMP_MIN_STKPADDING,               // Min value
+        KMP_MAX_STKPADDING,               // Max value
+        & __kmp_stkpadding                // Var to initialize
+    );
+} // __kmp_stg_parse_stackpad
+
+static void
+__kmp_stg_print_stackpad( kmp_str_buf_t * buffer, char const * name, void * data ) {
+    __kmp_stg_print_int( buffer, name, __kmp_stkpadding );
+} // __kmp_stg_print_stackpad
+
+// -------------------------------------------------------------------------------------------------
 // KMP_STACKOFFSET
 // -------------------------------------------------------------------------------------------------
 
@@ -1229,7 +1249,6 @@
 // OpenMP 3.0: KMP_TASKING, OMP_MAX_ACTIVE_LEVELS,
 // -------------------------------------------------------------------------------------------------
 
-#if OMP_30_ENABLED
 static void
 __kmp_stg_parse_tasking( char const * name, char const * value, void * data ) {
     __kmp_stg_parse_int( name, value, 0, (int)tskm_max, (int *)&__kmp_tasking_mode );
@@ -1259,7 +1278,41 @@
 __kmp_stg_print_max_active_levels( kmp_str_buf_t * buffer, char const * name, void * data ) {
     __kmp_stg_print_int( buffer, name, __kmp_dflt_max_active_levels );
 } // __kmp_stg_print_max_active_levels
-#endif // OMP_30_ENABLED
+
+#if KMP_NESTED_HOT_TEAMS
+// -------------------------------------------------------------------------------------------------
+// KMP_HOT_TEAMS_MAX_LEVEL, KMP_HOT_TEAMS_MODE
+// -------------------------------------------------------------------------------------------------
+
+static void
+__kmp_stg_parse_hot_teams_level( char const * name, char const * value, void * data ) {
+    if ( TCR_4(__kmp_init_parallel) ) {
+        KMP_WARNING( EnvParallelWarn, name );
+        return;
+    }   // read value before first parallel only
+    __kmp_stg_parse_int( name, value, 0, KMP_MAX_ACTIVE_LEVELS_LIMIT, & __kmp_hot_teams_max_level );
+} // __kmp_stg_parse_hot_teams_level
+
+static void
+__kmp_stg_print_hot_teams_level( kmp_str_buf_t * buffer, char const * name, void * data ) {
+    __kmp_stg_print_int( buffer, name, __kmp_hot_teams_max_level );
+} // __kmp_stg_print_hot_teams_level
+
+static void
+__kmp_stg_parse_hot_teams_mode( char const * name, char const * value, void * data ) {
+    if ( TCR_4(__kmp_init_parallel) ) {
+        KMP_WARNING( EnvParallelWarn, name );
+        return;
+    }   // read value before first parallel only
+    __kmp_stg_parse_int( name, value, 0, KMP_MAX_ACTIVE_LEVELS_LIMIT, & __kmp_hot_teams_mode );
+} // __kmp_stg_parse_hot_teams_mode
+
+static void
+__kmp_stg_print_hot_teams_mode( kmp_str_buf_t * buffer, char const * name, void * data ) {
+    __kmp_stg_print_int( buffer, name, __kmp_hot_teams_mode );
+} // __kmp_stg_print_hot_teams_mode
+
+#endif // KMP_NESTED_HOT_TEAMS
 
 // -------------------------------------------------------------------------------------------------
 // KMP_HANDLE_SIGNALS
@@ -1438,12 +1491,10 @@
     const char *var;
 
     /* ---------- Barrier branch bit control ------------ */
-
     for ( int i=bs_plain_barrier; i<bs_last_barrier; i++ ) {
         var = __kmp_barrier_branch_bit_env_name[ i ];
-
         if ( ( strcmp( var, name) == 0 ) && ( value != 0 ) ) {
-            char   *comma;
+            char *comma;
 
             comma = (char *) strchr( value, ',' );
             __kmp_barrier_gather_branch_bits[ i ] = ( kmp_uint32 ) __kmp_str_to_int( value, ',' );
@@ -1455,7 +1506,6 @@
 
                 if ( __kmp_barrier_release_branch_bits[ i ] > KMP_MAX_BRANCH_BITS ) {
                     __kmp_msg( kmp_ms_warning, KMP_MSG( BarrReleaseValueInvalid, name, comma + 1 ), __kmp_msg_null );
-
                     __kmp_barrier_release_branch_bits[ i ] = __kmp_barrier_release_bb_dflt;
                 }
             }
@@ -2037,11 +2087,6 @@
 # if OMP_40_ENABLED
     KMP_DEBUG_ASSERT( ( __kmp_nested_proc_bind.bind_types != NULL )
       && ( __kmp_nested_proc_bind.used > 0 ) );
-    if ( ( __kmp_affinity_notype != NULL )
-      && ( ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default )
-      || ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_intel ) ) ) {
-        type = TRUE;
-    }
 # endif
 
     while ( *buf != '\0' ) {
@@ -2049,29 +2094,53 @@
 
         if (__kmp_match_str("none", buf, (const char **)&next)) {
             set_type( affinity_none );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_false;
+# endif
             buf = next;
         } else if (__kmp_match_str("scatter", buf, (const char **)&next)) {
             set_type( affinity_scatter );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
             buf = next;
         } else if (__kmp_match_str("compact", buf, (const char **)&next)) {
             set_type( affinity_compact );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
             buf = next;
         } else if (__kmp_match_str("logical", buf, (const char **)&next)) {
             set_type( affinity_logical );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
             buf = next;
         } else if (__kmp_match_str("physical", buf, (const char **)&next)) {
             set_type( affinity_physical );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
             buf = next;
         } else if (__kmp_match_str("explicit", buf, (const char **)&next)) {
             set_type( affinity_explicit );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
             buf = next;
 # if KMP_MIC
         } else if (__kmp_match_str("balanced", buf, (const char **)&next)) {
             set_type( affinity_balanced );
+#  if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+#  endif
             buf = next;
 # endif
         } else if (__kmp_match_str("disabled", buf, (const char **)&next)) {
             set_type( affinity_disabled );
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_false;
+# endif
             buf = next;
         } else if (__kmp_match_str("verbose", buf, (const char **)&next)) {
             set_verbose( TRUE );
@@ -2451,6 +2520,9 @@
             __kmp_affinity_proclist = temp_proclist;
             __kmp_affinity_type = affinity_explicit;
             __kmp_affinity_gran = affinity_gran_fine;
+# if OMP_40_ENABLED
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+# endif
         }
         else {
             KMP_WARNING( AffSyntaxError, name );
@@ -2772,6 +2844,21 @@
     const char *scan = value;
     const char *next = scan;
     const char *kind = "\"threads\"";
+    kmp_setting_t **rivals = (kmp_setting_t **) data;
+    int rc;
+
+    rc = __kmp_stg_check_rivals( name, value, rivals );
+    if ( rc ) {
+        return;
+    }
+
+    //
+    // If OMP_PROC_BIND is not specified but OMP_PLACES is,
+    // then let OMP_PROC_BIND default to true.
+    //
+    if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default ) {
+        __kmp_nested_proc_bind.bind_types[0] = proc_bind_true;
+    }
 
     //__kmp_affinity_num_places = 0;
 
@@ -2805,10 +2892,17 @@
             __kmp_affinity_type = affinity_explicit;
             __kmp_affinity_gran = affinity_gran_fine;
             __kmp_affinity_dups = FALSE;
+            if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default ) {
+                 __kmp_nested_proc_bind.bind_types[0] = proc_bind_true;
+            }
         }
         return;
     }
 
+    if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default ) {
+        __kmp_nested_proc_bind.bind_types[0] = proc_bind_true;
+    }
+
     SKIP_WS(scan);
     if ( *scan == '\0' ) {
         return;
@@ -2855,8 +2949,7 @@
     }
     if ( ( __kmp_nested_proc_bind.used == 0 )
       || ( __kmp_nested_proc_bind.bind_types == NULL )
-      || ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_false )
-      || ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_intel ) ) {
+      || ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_false ) ) {
         __kmp_str_buf_print( buffer, ": %s\n", KMP_I18N_STR( NotDefined ) );
     }
     else if ( __kmp_affinity_type == affinity_explicit ) {
@@ -2913,7 +3006,7 @@
 
 # endif /* OMP_40_ENABLED */
 
-# if OMP_30_ENABLED && (! OMP_40_ENABLED)
+# if (! OMP_40_ENABLED)
 
 static void
 __kmp_stg_parse_proc_bind( char const * name, char const * value, void * data )
@@ -2943,7 +3036,7 @@
     }
 } // __kmp_parse_proc_bind
 
-# endif /* if OMP_30_ENABLED && (! OMP_40_ENABLED) */
+# endif /* if (! OMP_40_ENABLED) */
 
 
 static void
@@ -3132,11 +3225,7 @@
         buf = next;
         SKIP_WS( buf );
         __kmp_nested_proc_bind.used = 1;
-
-        //
-        // "true" currently maps to "spread"
-        //
-        __kmp_nested_proc_bind.bind_types[0] = proc_bind_spread;
+        __kmp_nested_proc_bind.bind_types[0] = proc_bind_true;
     }
     else {
         //
@@ -3454,7 +3543,7 @@
                     KMP_WARNING( InvalidClause, name, value );
                 } else
                     KMP_WARNING( EmptyClause, name );
-            } while ( value = semicolon ? semicolon + 1 : NULL );
+            } while ( (value = semicolon ? semicolon + 1 : NULL) );
         }
     }; // if
 
@@ -3499,7 +3588,6 @@
             else if (!__kmp_strcasecmp_with_sentinel("guided", value, ','))      /* GUIDED */
                 __kmp_sched = kmp_sch_guided_chunked;
 // AC: TODO: add AUTO schedule, and pprobably remove TRAPEZOIDAL (OMP 3.0 does not allow it)
-            #if OMP_30_ENABLED
             else if (!__kmp_strcasecmp_with_sentinel("auto", value, ',')) {       /* AUTO */
                 __kmp_sched = kmp_sch_auto;
                 if( comma ) {
@@ -3507,7 +3595,6 @@
                     comma = NULL;
                 }
             }
-            #endif // OMP_30_ENABLED
             else if (!__kmp_strcasecmp_with_sentinel("trapezoidal", value, ',')) /* TRAPEZOIDAL */
                 __kmp_sched = kmp_sch_trapezoidal;
             else if (!__kmp_strcasecmp_with_sentinel("static", value, ','))      /* STATIC */
@@ -4016,7 +4103,7 @@
             break;
         }
         // Next character is not an integer or not a comma OR number of values > 2 => end of list
-        if ( ( ( *next < '0' ) || ( *next > '9' ) ) && ( *next !=',') || ( total > 2 ) ) {
+        if ( ( ( *next < '0' || *next > '9' ) && *next !=',' ) || total > 2 ) {
             KMP_WARNING( EnvSyntaxError, name, value );
             return;
         }
@@ -4314,6 +4401,10 @@
 
 static void
 __kmp_stg_parse_omp_cancellation( char const * name, char const * value, void * data ) {
+    if ( TCR_4(__kmp_init_parallel) ) {
+        KMP_WARNING( EnvParallelWarn, name );
+        return;
+    }   // read value before first parallel only
     __kmp_stg_parse_bool( name, value, & __kmp_omp_cancellation );
 } // __kmp_stg_parse_omp_cancellation
 
@@ -4340,6 +4431,7 @@
     { "KMP_SETTINGS",                      __kmp_stg_parse_settings,           __kmp_stg_print_settings,           NULL, 0, 0 },
     { "KMP_STACKOFFSET",                   __kmp_stg_parse_stackoffset,        __kmp_stg_print_stackoffset,        NULL, 0, 0 },
     { "KMP_STACKSIZE",                     __kmp_stg_parse_stacksize,          __kmp_stg_print_stacksize,          NULL, 0, 0 },
+    { "KMP_STACKPAD",                      __kmp_stg_parse_stackpad,           __kmp_stg_print_stackpad,           NULL, 0, 0 },
     { "KMP_VERSION",                       __kmp_stg_parse_version,            __kmp_stg_print_version,            NULL, 0, 0 },
     { "KMP_WARNINGS",                      __kmp_stg_parse_warnings,           __kmp_stg_print_warnings,           NULL, 0, 0 },
 
@@ -4347,13 +4439,15 @@
     { "OMP_NUM_THREADS",                   __kmp_stg_parse_num_threads,        __kmp_stg_print_num_threads,        NULL, 0, 0 },
     { "OMP_STACKSIZE",                     __kmp_stg_parse_stacksize,          __kmp_stg_print_stacksize,          NULL, 0, 0 },
 
-#if OMP_30_ENABLED
     { "KMP_TASKING",                       __kmp_stg_parse_tasking,            __kmp_stg_print_tasking,            NULL, 0, 0 },
     { "KMP_TASK_STEALING_CONSTRAINT",      __kmp_stg_parse_task_stealing,      __kmp_stg_print_task_stealing,      NULL, 0, 0 },
     { "OMP_MAX_ACTIVE_LEVELS",             __kmp_stg_parse_max_active_levels,  __kmp_stg_print_max_active_levels,  NULL, 0, 0 },
     { "OMP_THREAD_LIMIT",                  __kmp_stg_parse_all_threads,        __kmp_stg_print_all_threads,        NULL, 0, 0 },
     { "OMP_WAIT_POLICY",                   __kmp_stg_parse_wait_policy,        __kmp_stg_print_wait_policy,        NULL, 0, 0 },
-#endif // OMP_30_ENABLED
+#if KMP_NESTED_HOT_TEAMS
+    { "KMP_HOT_TEAMS_MAX_LEVEL",           __kmp_stg_parse_hot_teams_level,    __kmp_stg_print_hot_teams_level,    NULL, 0, 0 },
+    { "KMP_HOT_TEAMS_MODE",                __kmp_stg_parse_hot_teams_mode,     __kmp_stg_print_hot_teams_mode,     NULL, 0, 0 },
+#endif // KMP_NESTED_HOT_TEAMS
 
 #if KMP_HANDLE_SIGNALS
     { "KMP_HANDLE_SIGNALS",                __kmp_stg_parse_handle_signals,     __kmp_stg_print_handle_signals,     NULL, 0, 0 },
@@ -4411,18 +4505,16 @@
 # ifdef KMP_GOMP_COMPAT
     { "GOMP_CPU_AFFINITY",                 __kmp_stg_parse_gomp_cpu_affinity,  NULL, /* no print */                NULL, 0, 0 },
 # endif /* KMP_GOMP_COMPAT */
-# if OMP_30_ENABLED
-#  if OMP_40_ENABLED
+# if OMP_40_ENABLED
     { "OMP_PROC_BIND",                     __kmp_stg_parse_proc_bind,          __kmp_stg_print_proc_bind,          NULL, 0, 0 },
     { "OMP_PLACES",                        __kmp_stg_parse_places,             __kmp_stg_print_places,             NULL, 0, 0 },
-#  else
+# else
     { "OMP_PROC_BIND",                     __kmp_stg_parse_proc_bind,          NULL, /* no print */                NULL, 0, 0 },
-#  endif /* OMP_40_ENABLED */
-# endif /* OMP_30_ENABLED */
+# endif /* OMP_40_ENABLED */
 
     { "KMP_TOPOLOGY_METHOD",               __kmp_stg_parse_topology_method,    __kmp_stg_print_topology_method,    NULL, 0, 0 },
 
-#elif !KMP_AFFINITY_SUPPORTED
+#else
 
     //
     // KMP_AFFINITY is not supported on OS X*, nor is OMP_PLACES.
@@ -4432,8 +4524,6 @@
     { "OMP_PROC_BIND",                     __kmp_stg_parse_proc_bind,          __kmp_stg_print_proc_bind,          NULL, 0, 0 },
 # endif
 
-#else
-    #error "Unknown or unsupported OS"
 #endif // KMP_AFFINITY_SUPPORTED
 
     { "KMP_INIT_AT_FORK",                  __kmp_stg_parse_init_at_fork,       __kmp_stg_print_init_at_fork,       NULL, 0, 0 },
@@ -4571,7 +4661,6 @@
 
         }
 
-#if OMP_30_ENABLED
         { // Initialize KMP_LIBRARY and OMP_WAIT_POLICY data.
 
             kmp_setting_t * kmp_library     = __kmp_stg_find( "KMP_LIBRARY" );        // 1st priority.
@@ -4595,21 +4684,12 @@
             }; // if
 
         }
-#else
-        {
-            kmp_setting_t * kmp_library = __kmp_stg_find( "KMP_LIBRARY" );
-            static kmp_stg_wp_data_t kmp_data = { 0, NULL };
-            kmp_library->data = & kmp_data;
-        }
-#endif /* OMP_30_ENABLED */
 
         { // Initialize KMP_ALL_THREADS, KMP_MAX_THREADS, and OMP_THREAD_LIMIT data.
 
             kmp_setting_t * kmp_all_threads  = __kmp_stg_find( "KMP_ALL_THREADS"  );  // 1st priority.
             kmp_setting_t * kmp_max_threads  = __kmp_stg_find( "KMP_MAX_THREADS"  );  // 2nd priority.
-#if OMP_30_ENABLED
             kmp_setting_t * omp_thread_limit = __kmp_stg_find( "OMP_THREAD_LIMIT" );  // 3rd priority.
-#endif
 
             // !!! volatile keyword is Intel (R) C Compiler bug CQ49908 workaround.
             static kmp_setting_t * volatile rivals[ 4 ];
@@ -4617,20 +4697,16 @@
 
             rivals[ i ++ ] = kmp_all_threads;
             rivals[ i ++ ] = kmp_max_threads;
-#if OMP_30_ENABLED
             if ( omp_thread_limit != NULL ) {
                 rivals[ i ++ ] = omp_thread_limit;
             }; // if
-#endif
             rivals[ i ++ ] = NULL;
 
             kmp_all_threads->data = (void*)& rivals;
             kmp_max_threads->data = (void*)& rivals;
-#if OMP_30_ENABLED
             if ( omp_thread_limit != NULL ) {
                 omp_thread_limit->data = (void*)& rivals;
             }; // if
-#endif
 
         }
 
@@ -4645,18 +4721,11 @@
             KMP_DEBUG_ASSERT( gomp_cpu_affinity != NULL );
 # endif
 
-# if OMP_30_ENABLED
             kmp_setting_t * omp_proc_bind = __kmp_stg_find( "OMP_PROC_BIND" );  // 3rd priority.
             KMP_DEBUG_ASSERT( omp_proc_bind != NULL );
-# endif
-
-# if OMP_40_ENABLED
-            kmp_setting_t * omp_places = __kmp_stg_find( "OMP_PLACES" );  // 3rd priority.
-            KMP_DEBUG_ASSERT( omp_places != NULL );
-# endif
 
             // !!! volatile keyword is Intel (R) C Compiler bug CQ49908 workaround.
-            static kmp_setting_t * volatile rivals[ 5 ];
+            static kmp_setting_t * volatile rivals[ 4 ];
             int i = 0;
 
             rivals[ i ++ ] = kmp_affinity;
@@ -4666,23 +4735,30 @@
             gomp_cpu_affinity->data = (void*)& rivals;
 # endif
 
-# if OMP_30_ENABLED
             rivals[ i ++ ] = omp_proc_bind;
             omp_proc_bind->data = (void*)& rivals;
-# endif
+            rivals[ i ++ ] = NULL;
 
 # if OMP_40_ENABLED
-            rivals[ i ++ ] = omp_places;
-            omp_places->data = (void*)& rivals;
-# endif
+            static kmp_setting_t * volatile places_rivals[ 4 ];
+            i = 0;
 
-            rivals[ i ++ ] = NULL;
-        }
+            kmp_setting_t * omp_places = __kmp_stg_find( "OMP_PLACES" );  // 3rd priority.
+            KMP_DEBUG_ASSERT( omp_places != NULL );
 
+            places_rivals[ i ++ ] = kmp_affinity;
+#  ifdef KMP_GOMP_COMPAT
+            places_rivals[ i ++ ] = gomp_cpu_affinity;
+#  endif
+            places_rivals[ i ++ ] = omp_places;
+            omp_places->data = (void*)& places_rivals;
+            places_rivals[ i ++ ] = NULL;
+# endif
+        }
 #else
     // KMP_AFFINITY not supported, so OMP_PROC_BIND has no rivals.
     // OMP_PLACES not supported yet.
-#endif
+#endif // KMP_AFFINITY_SUPPORTED
 
         { // Initialize KMP_DETERMINISTIC_REDUCTION and KMP_FORCE_REDUCTION data.
 
@@ -4917,8 +4993,33 @@
           && ( FIND( aff_str, "disabled" ) == NULL ) ) {
             __kmp_affinity_notype = __kmp_stg_find( "KMP_AFFINITY"  );
         }
+        else {
+            //
+            // A new affinity type is specified.
+            // Reset the affinity flags to their default values,
+            // in case this is called from kmp_set_defaults().
+            //
+            __kmp_affinity_type = affinity_default;
+            __kmp_affinity_gran = affinity_gran_default;
+            __kmp_affinity_top_method = affinity_top_method_default;
+            __kmp_affinity_respect_mask = affinity_respect_mask_default;
+        }
 # undef FIND
+
+#if OMP_40_ENABLED
+        //
+        // Also reset the affinity flags if OMP_PROC_BIND is specified.
+        //
+        aff_str = __kmp_env_blk_var( & block, "OMP_PROC_BIND" );
+        if ( aff_str != NULL ) {
+            __kmp_affinity_type = affinity_default;
+            __kmp_affinity_gran = affinity_gran_default;
+            __kmp_affinity_top_method = affinity_top_method_default;
+            __kmp_affinity_respect_mask = affinity_respect_mask_default;
+        }
+#endif /* OMP_40_ENABLED */
     }
+
 #endif /* KMP_AFFINITY_SUPPORTED */
 
 #if OMP_40_ENABLED
@@ -4956,9 +5057,15 @@
     else {
         KMP_DEBUG_ASSERT( string != NULL); // kmp_set_defaults() was called
         KMP_DEBUG_ASSERT( __kmp_user_lock_kind != lk_default );
+        __kmp_set_user_lock_vptrs( __kmp_user_lock_kind );
+        // Binds lock functions again to follow the transition between different
+        // KMP_CONSISTENCY_CHECK values. Calling this again is harmless as long
+        // as we do not allow lock kind changes after making a call to any
+        // user lock functions (true).
     }
 
 #if KMP_AFFINITY_SUPPORTED
+
     if ( ! TCR_4(__kmp_init_middle) ) {
         //
         // Determine if the machine/OS is actually capable of supporting
@@ -4984,102 +5091,87 @@
         }
 
 # if OMP_40_ENABLED
-
         if ( __kmp_affinity_type == affinity_disabled )  {
             __kmp_nested_proc_bind.bind_types[0] = proc_bind_disabled;
         }
-        else if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default ) {
+        else if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_true ) {
             //
-            // Where supported the default is to use the KMP_AFFINITY
-            // mechanism.  On OS X* etc. it is none.
+            // OMP_PROC_BIND=true maps to OMP_PROC_BIND=spread.
             //
-#  if KMP_AFFINITY_SUPPORTED
-            __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
-#  else
-            __kmp_nested_proc_bind.bind_types[0] = proc_bind_false;
-#  endif
-        }
-
-        //
-        // If OMP_PROC_BIND was specified (so we are using OpenMP 4.0 affinity)
-        // but OMP_PLACES was not, then it defaults to the equivalent of
-        // KMP_AFFINITY=compact,noduplicates,granularity=fine.
-        //
-        if ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_intel ) {
-            if ( ( __kmp_affinity_type == affinity_none )
-#  if ! KMP_MIC
-              || ( __kmp_affinity_type == affinity_default )
-#  endif
-              ) {
-                  __kmp_nested_proc_bind.bind_types[0] = proc_bind_false;
-            }
+            __kmp_nested_proc_bind.bind_types[0] = proc_bind_spread;
         }
-        else if ( ( __kmp_nested_proc_bind.bind_types[0] != proc_bind_false )
-          && ( __kmp_nested_proc_bind.bind_types[0] != proc_bind_disabled ) ) {
-            if ( __kmp_affinity_type == affinity_default ) {
-                __kmp_affinity_type = affinity_compact;
-                __kmp_affinity_dups = FALSE;
-            }
-            if ( __kmp_affinity_gran == affinity_gran_default ) {
-                __kmp_affinity_gran = affinity_gran_fine;
-            }
-        }
-# endif //  OMP_40_ENABLED
+# endif /* OMP_40_ENABLED */
 
         if ( KMP_AFFINITY_CAPABLE() ) {
 
 # if KMP_OS_WINDOWS && KMP_ARCH_X86_64
 
-            if ( __kmp_num_proc_groups > 1 ) {
+            //
+            // Handle the Win 64 group affinity stuff if there are multiple
+            // processor groups, or if the user requested it, and OMP 4.0
+            // affinity is not in effect.
+            //
+            if ( ( ( __kmp_num_proc_groups > 1 )
+              && ( __kmp_affinity_type == affinity_default )
+#  if OMP_40_ENABLED
+              && ( __kmp_nested_proc_bind.bind_types[0] == proc_bind_default ) )
+#  endif
+              || ( __kmp_affinity_top_method == affinity_top_method_group ) ) {
                 if ( __kmp_affinity_respect_mask == affinity_respect_mask_default ) {
-                   __kmp_affinity_respect_mask = FALSE;
+                    __kmp_affinity_respect_mask = FALSE;
                 }
-
-                if ( ( __kmp_affinity_type == affinity_default )
-                  || ( __kmp_affinity_type == affinity_none ) ) {
-                    if ( __kmp_affinity_type == affinity_none ) {
-                        if ( __kmp_affinity_verbose || ( __kmp_affinity_warnings
-                          && ( __kmp_affinity_type != affinity_none ) ) ) {
-                            KMP_WARNING( AffTypeCantUseMultGroups, "none", "compact" );
-                        }
-                    }
+                if ( __kmp_affinity_type == affinity_default ) {
                     __kmp_affinity_type = affinity_compact;
-                    if ( __kmp_affinity_top_method == affinity_top_method_default ) {
-                       __kmp_affinity_top_method = affinity_top_method_group;
-                    }
+#  if OMP_40_ENABLED
+                    __kmp_nested_proc_bind.bind_types[0] = proc_bind_intel;
+#  endif
                 }
-                else if ( __kmp_affinity_top_method == affinity_top_method_default ) {
-                    __kmp_affinity_top_method = affinity_top_method_all;
+                if ( __kmp_affinity_top_method == affinity_top_method_default ) {
+                    if ( __kmp_affinity_gran == affinity_gran_default ) {
+                        __kmp_affinity_top_method = affinity_top_method_group;
+                        __kmp_affinity_gran = affinity_gran_group;
+                    }
+                    else if ( __kmp_affinity_gran == affinity_gran_group ) {
+                        __kmp_affinity_top_method = affinity_top_method_group;
+                    }
+                    else {
+                        __kmp_affinity_top_method = affinity_top_method_all;
+                    }
                 }
-
-                if ( __kmp_affinity_gran_levels < 0 ) {
-                    if ( __kmp_affinity_top_method == affinity_top_method_group ) {
-                        if ( __kmp_affinity_gran == affinity_gran_default ) {
-                           __kmp_affinity_gran = affinity_gran_group;
-                        }
-                        else if ( __kmp_affinity_gran == affinity_gran_core ) {
-                            if ( __kmp_affinity_verbose || ( __kmp_affinity_warnings
-                              && ( __kmp_affinity_type != affinity_none ) ) ) {
-                                KMP_WARNING( AffGranCantUseMultGroups, "core", "thread" );
-                            }
-                            __kmp_affinity_gran = affinity_gran_thread;
-                        }
-                        else if ( __kmp_affinity_gran == affinity_gran_package ) {
-                            if ( __kmp_affinity_verbose || ( __kmp_affinity_warnings
-                              && ( __kmp_affinity_type != affinity_none ) ) ) {
-                                KMP_WARNING( AffGranCantUseMultGroups, "package", "group" );
-                            }
-                           __kmp_affinity_gran = affinity_gran_group;
-                        }
-                        else if ( __kmp_affinity_gran == affinity_gran_node ) {
-                            if ( __kmp_affinity_verbose || ( __kmp_affinity_warnings
-                              && ( __kmp_affinity_type != affinity_none ) ) ) {
-                                KMP_WARNING( AffGranCantUseMultGroups, "node", "group" );
-                            }
-                           __kmp_affinity_gran = affinity_gran_group;
+                else if ( __kmp_affinity_top_method == affinity_top_method_group ) {
+                    if ( __kmp_affinity_gran == affinity_gran_default ) {
+                        __kmp_affinity_gran = affinity_gran_group;
+                    }
+                    else if ( ( __kmp_affinity_gran != affinity_gran_group )
+                      && ( __kmp_affinity_gran != affinity_gran_fine )
+                      && ( __kmp_affinity_gran != affinity_gran_thread ) ) {
+                        char *str = NULL;
+                        switch ( __kmp_affinity_gran ) {
+                            case affinity_gran_core: str = "core"; break;
+                            case affinity_gran_package: str = "package"; break;
+                            case affinity_gran_node: str = "node"; break;
+                            default: KMP_DEBUG_ASSERT( 0 );
                         }
+                        KMP_WARNING( AffGranTopGroup, var, str );
+                        __kmp_affinity_gran = affinity_gran_fine;
                     }
-                    else if ( __kmp_affinity_gran == affinity_gran_default ) {
+                }
+                else {
+                    if ( __kmp_affinity_gran == affinity_gran_default ) {
+                        __kmp_affinity_gran = affinity_gran_core;
+                    }
+                    else if ( __kmp_affinity_gran == affinity_gran_group ) {
+                        char *str = NULL;
+                        switch ( __kmp_affinity_type ) {
+                            case affinity_physical: str = "physical"; break;
+                            case affinity_logical: str = "logical"; break;
+                            case affinity_compact: str = "compact"; break;
+                            case affinity_scatter: str = "scatter"; break;
+                            case affinity_explicit: str = "explicit"; break;
+                            // No MIC on windows, so no affinity_balanced case
+                            default: KMP_DEBUG_ASSERT( 0 );
+                        }
+                        KMP_WARNING( AffGranGroupType, var, str );
                         __kmp_affinity_gran = affinity_gran_core;
                     }
                 }
